/**
 * generated by Xtext 2.18.0.M3
 */
package tdt4250.ra.tests;

import com.google.inject.Inject;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.testing.InjectWith;
import org.eclipse.xtext.testing.XtextRunner;
import org.eclipse.xtext.testing.util.ParseHelper;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import tdt4250.ra.rax1.Course;
import tdt4250.ra.rax1.Department;
import tdt4250.ra.rax1.Person;

@RunWith(XtextRunner.class)
@InjectWith(Rax1InjectorProvider.class)
@SuppressWarnings("all")
public class Rax1ParsingTest {
  @Inject
  private ParseHelper<Department> parseHelper;

  @Test
  public void loadModel() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("IDI - \"Dept. of CS\"");
      _builder.newLine();
      _builder.newLine();
      _builder.append("Persons:");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("\"Hallvard Trætteberg\"");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("Adrian");
      _builder.newLine();
      _builder.newLine();
      _builder.append("Courses:");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("TDT4250 - \"Advanced Software Design\": \"Hallvard Trætteberg\" 100%");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("IT1901 - InfProj: Adrian 70%, \"Hallvard Trætteberg\" 30%");
      _builder.newLine();
      _builder.newLine();
      final Department result = this.parseHelper.parse(_builder);
      Assert.assertNotNull(result);
      final EList<Resource.Diagnostic> errors = result.eResource().getErrors();
      StringConcatenation _builder_1 = new StringConcatenation();
      _builder_1.append("Unexpected errors: ");
      String _join = IterableExtensions.join(errors, ", ");
      _builder_1.append(_join);
      Assert.assertTrue(_builder_1.toString(), errors.isEmpty());
      int _size = result.getPersons().size();
      this.operator_spaceship(
        Integer.valueOf(2), Integer.valueOf(_size));
      final Person hallvard = result.getPersons().get(0);
      final Person adrian = result.getPersons().get(1);
      int _size_1 = result.getCourses().size();
      this.operator_spaceship(
        Integer.valueOf(2), Integer.valueOf(_size_1));
      final Course tdt4250 = result.getCourses().get(0);
      final Course it1901 = result.getCourses().get(1);
      int _size_2 = tdt4250.getAllocations().size();
      this.operator_spaceship(
        Integer.valueOf(1), Integer.valueOf(_size_2));
      Person _person = tdt4250.getAllocations().get(0).getPerson();
      this.operator_spaceship(hallvard, _person);
      int _percentage = tdt4250.getAllocations().get(0).getPercentage();
      this.operator_spaceship(
        Integer.valueOf(100), Integer.valueOf(_percentage));
      int _size_3 = it1901.getAllocations().size();
      this.operator_spaceship(
        Integer.valueOf(2), Integer.valueOf(_size_3));
      Person _person_1 = it1901.getAllocations().get(0).getPerson();
      this.operator_spaceship(adrian, _person_1);
      int _percentage_1 = it1901.getAllocations().get(0).getPercentage();
      this.operator_spaceship(
        Integer.valueOf(70), Integer.valueOf(_percentage_1));
      Person _person_2 = it1901.getAllocations().get(1).getPerson();
      this.operator_spaceship(hallvard, _person_2);
      int _percentage_2 = it1901.getAllocations().get(1).getPercentage();
      this.operator_spaceship(
        Integer.valueOf(30), Integer.valueOf(_percentage_2));
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }

  private void operator_spaceship(final Object expected, final Object actual) {
    Assert.assertEquals(expected, actual);
  }
}
